import java.io.FileNotFoundException;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Set;


//Driver for VerbOwl Afrikaans  Ontology verbaliser;
//Imports the OWL file, turns it into functional syntax. Then extract the words which are needed for translation and sends them to the translation program.

public class Driver {
   private static double miliseconds = 1000000000.0;
   public static void main(String[] args) throws FileNotFoundException, UnsupportedEncodingException {
   	//Write the functionalSyntax to a file.
   	
   	//Add way to specifiy ontology is afrikaans
      long startTime = System.nanoTime();
   	
   	//useful for testing
      String[] ontologyNames = new String[] {"AfricanWildlife.owl", "computerscience.owl", "pizza.owl", "stuff.owl", "university.owl", "wine.rdf"};
   	
      String filename = ontologyNames[0];
      System.out.println ("Verbalising: "+ filename);
      System.out.println("Extracting functional syntax from OWL file");
      ImportOwl.toFunctionalSyntax(filename, false);
   	//Extract unique words from functionalSyntax and write them to a file.
      Set<String> wordsForTranslation = ProcessFile.extractClasses("functionalSyntax.txt");
      System.out.println("Extracting english words for translation");
      ArrayList<String[]>  translatedWords = ProcessFile.translateClasses(wordsForTranslation);
      System.out.println("Translating english words");
      ProcessFile.createGFFiles(wordsForTranslation, translatedWords);
      System.out.println("Setting up GF files");
   	//Takes the file name without the extension to feed into prepareForlinearisation. 
   	//This is done so that the output filename mimics that of the input file 
      String filenameWithoutExtention = filename.split("\\.")[0];
      ProcessFile.prepareForLinearisation("verbalised/"+filenameWithoutExtention);
      long endtime = System.nanoTime();
      long duration = (endtime - startTime);
      System.out.println("Time taken: "+duration/miliseconds); //divide by 1000000 to get milliseconds.
   }
}